# WORKING MODEL APRIL 2021
library(colorspace)
library(scales)
library(RColorBrewer)

coefz.p <- readRDS('FS_COEFS_dis.RDS')$COEFP
coefz.x <- readRDS('FS_COEFS_dis.RDS')$COEFX
timelength <- 100
limit <- 10
# taxes <- c(0,.01,.02,.03,.04,.05,.06,.07,.08,.09,.1,.11,.12)
taxes <- seq(.14,.24,by=.02)
alphas <- c(0,.1,.25,.5,.75,1)
# taxes<-c(seq(0,0.01,by=0.0025),0.015,0.02,0.025,0.03,0.035,0.04,0.045,0.05)
thetak<-seq(0.7,1.1,by=0.1)
qq0 <- c(.01,.025,0.05,.1,.25) # seq(0.2,0.8,by=0.2)
phase <- array(NA,dim=c(5,length(qq0),length(thetak),length(taxes),length(alphas)),dimnames=list(cou0[-6],qq0,thetak,taxes,alphas))
for(zou in cou0[-6])
{
  print(zou)
  for(tax in taxes)
  {
    print(tax)
    for(theta in thetak)
    {
      for(q_0 in qq0)
      {
        for(alpha in alphas)
          {
        #   q_0 <- qq0[q__0]
        # tax <- taxes[tt]
        # theta <- thetak[theta0]
        gam <- 0
        subsidy<- T
        tax_ation <- T
        innovation <- T
        TIO <- 10
        # zou <- fou
        if(zou == 'JPN') {thesector <- 'D' } else {thesector <- 'C19'}
        # 'B', 'C19', 'D'
        
        dp <- coefz.p[zou,]
        dx <- coefz.x[zou,]
        seko <- dimnames(coefz.p)[[2]][dp>0 & dx>0]
        seko <- seko[!is.na(seko)]
        dp <- dp[seko]
        dx <- dx[seko]
        A <- io[zou,15,seko,seko]
        q0 <- abs(Re(eigen(A)$vectors[,1]))
        seko <- seko[ q0 != 0 ]
        q0 <- q0[q0 != 0]
        dp <- dp[seko]
        dx <- dx[seko]
        A <- A[seko,seko]
        N <- K <- nrow(A)
        Kmax <- K+1
        
        p_0 <- abs(Re(t(eigen(t(A))$vectors[,1])))
        lastyear<-22
        if(zou=='JPN' | zou=='ITA'){lastyear<-21}
        p0 <- p_0 * p_go[zou,seko,lastyear]/rowMeans(p_go[zou,seko,],na.rm=T)
        x0 <- go_q[zou,seko,15]/(q0*mean(go_q[zou,seko,15]/q0,na.rm=T))
        Rt <- taxt <- Nt <- c()
        Rt[1] <- sum(p0 * x0) / p0 %*% A %*% x0 # R <- R.[which(zou==dimnames(coefz.p)[[1]]),15]
        Nt[1] <- N
        
        taxt[1:TIO]<-0
        phaseout <- rep(NA,TIO)
        labels <- c('k','p','X',paste0('a',1:Kmax),paste0('b',1:Kmax),'M','r','pi','g')
        capital<-array(0,dim=c(Kmax,length(labels),timelength),dimnames=list(paste0('K',1:Kmax),labels,paste0('t',c(1:timelength))))
        capital[1:N,c('p','X'),1]<-c(p0,x0)
        capital[1:N,paste0('a',1:K),1]<-t(A)
        capital[1:N,paste0('b',1:K),1]<-t(B<-diag(K))
        capital[1:N,'k',1]<-1:K
        capital[1:N,'M',1]<-capital[1:N,'p',1] %*% A * capital[1:N,'X',1]
        capital[1:N,'pi',1]<-capital[1:N,'p',1]*capital[1:N,'X',1]
        capital[1:N,'r',1]<-capital[1:N,'p',1]*t(B %*% capital[1:N,'X',1])/(capital[1:N,'p',1] %*% A * capital[1:N,'X',1])-1
        
        for (t in 1:(timelength-1))
        {
          # INNOVATION
          if(t==TIO & innovation)
          {
            target<-which(capital[1:N,'k',t]==which(seko==thesector))
            capital[(target+1):(N+1),,t]<-capital[target:N,,t]
            capital[target+1,paste0('a',1:K),t]<-theta*capital[target+1,paste0('a',1:K),t]
            capital[target+1,'X',t]<-q_0*capital[target+1,'X',t]
            N<-N+1
            sectors <- which(capital[1:N,'k',t]==which(seko==thesector))
          }
          A <- t(capital[1:N,paste0('a',1:K),t])
          B <- t(capital[1:N,paste0('b',1:K),t])
          C <- B-Rt[t]*A
          
          cnt <- sapply(lapply(1:K,function(k)(which(capital[,'k',t]==k))),"[",1)
          P <- t(capital[cnt,'p',t])
          X <- t(t(capital[1:N,'X',t]))
          capital[1:N,'p',t+1] <- (P-dp*P*t(C %*% X))[capital[1:N,'k',t]]
          s<--t(C) %*% diag(dp*as.vector(P)) %*% C
          capital[1:N,'X',t+1]<-X+dx[capital[1:N,'k',t]]*X*(t(C) %*% t(P) + gam*(s %*% X))
          
          Rt[t+1]<-(P %*% B %*% X)/(P %*% A %*% X)
          Nt[t+1] <- N
          capital[1:N,paste0('a',1:K),t+1]<-t(A)
          capital[1:N,paste0('b',1:K),t+1]<-t(B)
          capital[1:N,'k',t+1]<-capital[1:N,'k',t]
          
          if(t>TIO & tax_ation)
          {
            taxation <- tax*capital[sectors[1],'X',t+1]
            taxt[t+1] <- taxation
            capital[sectors[1],'X',t+1] <- capital[sectors[1],'X',t+1]-taxation
            if(subsidy){capital[sectors[2],'X',t+1] <- capital[sectors[2],'X',t+1]+alpha*taxation}
          }
          
          capital[1:N,'M',t+1] <- capital[cnt,'p',t+1] %*% A * capital[1:N,'X',t+1]
          capital[1:N,'g',t] <- capital[1:N,'M',t+1]/capital[1:N,'M',t]-1
          capital[1:N,'pi',t+1] <- capital[1:N,'p',t+1]*capital[1:N,'X',t+1] # P * t(B %*% X)
          capital[1:N,'r',t+1] <- capital[1:N,'p',t+1]*capital[1:N,'X',t+1]/(capital[cnt,'p',t+1] %*% A * capital[1:N,'X',t+1])-1
          
          if(t>TIO & innovation) 
          { 
            phaseout[t]<-capital[sectors[2],'X',t]/capital[sectors[1],'X',t]
          }
        }
        capital[sectors[2],c('r','g'),TIO]<-NA
        capital[,'g',1]<-NA
        capital[,'g',t+1]<-capital[,'M',t+1]/capital[,'M',t]-1
        duration <- which(phaseout>limit)[which(which(phaseout>1)>TIO)][1] - TIO
        
        # phase[fou,tt,theta,q__0] <- duration
        # phase[t(as.character(c(zou,q__0,theta0,tax,alpha)))]
        phase[zou,as.character(q_0),as.character(theta),as.character(tax),as.character(alpha)] <- duration
      }
    }
  } 
  }
}
phase_long1 <- melt(phase,varnames=c('geo','q0','eff','tax','subsidy'))
phaselong <- rbind(phase_long,phase_long1)
saveRDS(phaselong,file="phaselong_10_total.RDS")

# q, eff, tax, alpha
phase_wo_subsidy <- phase
ipcc <- 1/c(16,23,51,65)

# phase_wo_subsidy 
par(mfrow=c(1,1))
plot(NA,xlim=c(0,0.05),ylim=c(0,400))
grid()
for(k in 1:length(alphas)) 
{
  df <- subset(phase_long,geo=='DEU' & eff==1 & q0==.05 & subsidy==alphas[k],select=c(tax,value))  
  points(df$tax,df$value,lwd=2.25,col=rainbow_hcl(n=length(alphas))[k],type='o')
}

# Adjustment speed increases linearly with taxation
plot(NA,xlim=c(0,0.05),ylim=c(0,.1))
grid()
for(k in 1:length(alphas)) 
{
  df <- subset(phase_long,geo=='DEU' & eff==.8 & q0==.05 & subsidy==alphas[k],select=c(tax,value))  
  points(df$tax,1/df$value,lwd=2.25,col=rainbow_hcl(n=length(alphas))[k],type='o')
}
legend('topleft',legend=alphas,pch=16,col=rainbow_hcl(n=length(alphas)),bty='n')
abline(h=ipcc,lty=2)

library(reshape2)
library(gridExtra)
library(ggplot2)


df <- subset(phase_long,q0==.05 & subsidy==1)  
df$eff <- as.factor(df$eff)
ggplot(data=df, aes(x=tax, y=1/value, group=geo, color=eff)) + geom_point() +  facet_wrap(~geo) + geom_smooth(method=lm, se=FALSE, fullrange=TRUE)


geom_point()+
  geom_smooth(method=lm)
ggplot(data=phaselong, aes(x=value, group=geo, fill=geo)) +
  geom_density(adjust=1.5, alpha=0.7) +  facet_wrap(~geo) + geom_vline(xintercept=0, linetype="dotted") + 
  theme(
    legend.position="none",
    panel.spacing = unit(0.1, "lines"),
    axis.ticks.x=element_blank()
  ) 

phaselong0 <- melt(phase[,,1,5],varnames=c('geo','efficiency','init.X'))
pfig<-list()
for(fou in 1:5)
{
  pfig[[fou]]<-ggplot(data=phaselong0[phaselong0$geo==cou0[fou],],
                      aes(x=init.X, y=efficiency, fill=value)) + geom_tile() + ggtitle(cou0[fou]) +
    geom_text(aes(label=value), color='white') + theme_bw() + theme(plot.title = element_text(face="bold"),legend.position = "none")
}
grid.arrange(pfig[[1]],pfig[[2]],pfig[[3]],pfig[[4]],pfig[[5]],nrow=2)#,top='Gross capital formation as % of GDP')

ipcc <- 1/c(16,23,51,65)

# Adjustment speed increases linearly with taxation
# phaselong <- phase_long
crit.x <- unique(phaselong$tax)
plot(NA,xlim=c(min(crit.x),max(crit.x)),ylim=c(0,.1),main='Speed increases linearly with tax rate',ylab='Speed',xlab='Tax Rate')
grid()
eff0 <- .7
q__0 <- .1
subsidy.rates <- unique(phaselong$subsidy)
lm.tax <- list()
for(k in 1:length(subsidy.rates)) 
{
  df <- subset(phaselong,geo=='DEU' & eff==eff0 & q0==q__0 & subsidy==subsidy.rates[k],select=c(tax,value))  
  points(crit.x,1/df$value,lwd=2.25,col=rainbow_hcl(n=length(subsidy.rates))[k],type='o')
  lm.tax[[k]] <- lm(1/df$value ~ crit.x)
}
legend('topleft',legend=subsidy.rates,pch=16,col=rainbow_hcl(n=length(subsidy.rates)),bty='n',title='Subsidy Rates')
abline(h=ipcc,lty=2,col='darkred')
mtext(paste0('Efficiency = ',eff0,'; Initial Investment = ',q__0),side=3,line=.5,cex=.8)
lm.tax.summary <- lapply(lm.tax, function(x) {summary(x)$coefficients})
tax.slopes <- sapply(lm.tax, function(x) {summary(x)$coefficients['crit.x','Estimate']})
plot(subsidy.rates,tax.slopes)
summary(lm(tax.slopes ~ subsidy.rates))


par(mfrow=c(2,2))
for (i in 1:4)
{
  q__0 <- c(.01,.05,.1,.25)[i]
  
plot(NA,xlim=c(min(crit.x),max(crit.x)),ylim=c(0,.1),main=paste0('Initial Output Ratio = ',q__0),ylab='',xlab='',las=1)
grid()
eff0 <- 1
zou <- 'DEU'
subsidy.rates <- unique(phaselong$subsidy)
# lm.tax <- list()
for(k in 1:length(subsidy.rates)) 
{
  df <- subset(phaselong,geo==zou & eff==eff0 & q0==q__0 & subsidy==subsidy.rates[k],select=c(tax,value))  
  points(crit.x,1/df$value,lwd=2.25,col=rainbow_hcl(n=length(subsidy.rates))[k],type='o')
  # lm.tax[[k]] <- lm(1/df$value ~ crit.x)
}
legend('topleft',legend=subsidy.rates,pch=16,col=rainbow_hcl(n=length(subsidy.rates)),bty='n',title='Subsidy Rates')
abline(h=ipcc,lty=2,col='darkred')
# mtext(paste0('Efficiency = ',eff0,'; Initial Investment = ',q__0),side=3,line=.5,cex=.8)
}
lm.tax.summary <- lapply(lm.tax, function(x) {summary(x)$coefficients})
tax.slopes <- sapply(lm.tax, function(x) {summary(x)$coefficients['crit.x','Estimate']})
plot(subsidy.rates,tax.slopes)
summary(lm(tax.slopes ~ subsidy.rates))

df <- phaselong
df$speed <- 1/df$value
summary(lm(speed ~ q0 + eff + tax + subsidy,df))
